package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Time
	 */
	public class Cell extends Entity
	{
		public var cFill:Number = 0;
		public var lFill:Number = 0;
		
		private var maxFill:int = 200;
		
		private var i:int;
		private var j:int;
		
		public function Cell(_x:int, _y:int) 
		{
			super(_x * Game.grid, _y * Game.grid);
			i = _x;
			j = _y;
			
			active = false;
		}
		
		override public function update():void
		{
			if (cFill > 0)
			{
				var rate:Number = cFill/4;
				
				var r:int = i + 1;
				var l:int = i - 1;
				var d:int = j + 1;
				var u:int = j - 1;
				if (r >= Game.cells.length)
				{
					r = 0;
				}
				if (l < 0)
				{
					l = Game.cells.length - 1;
				}
				if (d >= Game.cells[i].length)
				{
					d = 0;
				}
				if (u < 0)
				{
					u = Game.cells[i].length-1;
				}
				if (Game.cells[l][j].cFill + rate / 4 <= maxFill)
				{
					Game.cells[l][j].cFill += rate / 4;
					cFill -= rate / 4;
				}
				if (Game.cells[r][j].cFill + rate / 4 <= maxFill)
				{
					Game.cells[r][j].cFill += rate / 4;
					cFill -= rate / 4;
				}
				if (Game.cells[i][d].cFill + rate / 4 <= maxFill)
				{
					Game.cells[i][d].cFill += rate / 4;
					cFill -= rate / 4;
				}
				if (Game.cells[i][u].cFill + rate / 4 <= maxFill)
				{
					Game.cells[i][u].cFill += rate / 4;
					cFill -= rate / 4;
				}
				cFill -= 0.1;
			}
			
			if (Math.abs(Math.round(Input.mouseX / Game.grid) * Game.grid - x) <= Game.grid && Math.abs(Math.round(Input.mouseY / Game.grid) * Game.grid - y) <= Game.grid)
			{
				cFill = maxFill;
				if (Input.mouseDown)
				{
					cFill = -maxFill;
				}
			}
			
			layer = -cFill;
		}
		
		override public function render():void
		{
			var w:int = Game.grid * (0.9 + cFill / maxFill);
			var c:uint = FP.getColorRGB(0, (1 - cFill/maxFill) * 255, cFill / maxFill * 255);
			Draw.rect(x - w/2, y - w/2, w, w, c);
		}
	}

}